package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigReportTypePageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigReportTypeRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigReportTypeSaveReqVO;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigReportTypeDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.qms.business.config.dal.mapper.ConfigReportTypeMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.CONFIG_REPORT_TYPE_NOT_EXISTS;

/**
 * 报表类型配置 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigReportTypeServiceImpl implements ConfigReportTypeService {

    @Resource
    private ConfigReportTypeMapper configReportTypeMapper;

    @Override
    public ConfigReportTypeRespVO createConfigReportType(ConfigReportTypeSaveReqVO createReqVO) {
        // 插入
        ConfigReportTypeDO configReportType = BeanUtils.toBean(createReqVO, ConfigReportTypeDO.class);
        configReportTypeMapper.insert(configReportType);
        // 返回
        return BeanUtils.toBean(configReportType, ConfigReportTypeRespVO.class);
    }

    @Override
    public void updateConfigReportType(ConfigReportTypeSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigReportTypeExists(updateReqVO.getId());
        // 更新
        ConfigReportTypeDO updateObj = BeanUtils.toBean(updateReqVO, ConfigReportTypeDO.class);
        configReportTypeMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigReportType(Long id) {
        // 校验存在
        validateConfigReportTypeExists(id);
        // 删除
        configReportTypeMapper.deleteById(id);
    }

    @Override
        public void deleteConfigReportTypeListByIds(List<Long> ids) {
        // 校验存在
        validateConfigReportTypeExists(ids);
        // 删除
        configReportTypeMapper.deleteByIds(ids);
        }

    private void validateConfigReportTypeExists(List<Long> ids) {
        List<ConfigReportTypeDO> list = configReportTypeMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_REPORT_TYPE_NOT_EXISTS);
        }
    }

    private void validateConfigReportTypeExists(Long id) {
        if (configReportTypeMapper.selectById(id) == null) {
            throw exception(CONFIG_REPORT_TYPE_NOT_EXISTS);
        }
    }

    @Override
    public ConfigReportTypeDO getConfigReportType(Long id) {
        return configReportTypeMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigReportTypeDO> getConfigReportTypePage(ConfigReportTypePageReqVO pageReqVO) {
        return configReportTypeMapper.selectPage(pageReqVO);
    }

}